/**
 * MCS Media Computer Software
 * Copyright 2018 by Wilfried Klaas
 * Project: MCSUtils
 * File: Option.java
 * EMail: W.Klaas@gmx.de
 * Created: 29.11.2018 wklaa_000
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 */
package de.mcs.utils.jsap;

import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

@Retention(RUNTIME)
@Target({ FIELD, METHOD })
/**
 * @author wklaa_000
 *
 */
public @interface StringOption {
  char shortKey() default ' ';

  String longKey() default "";

  String name();

  String help();

  String defaultValue() default "";

  boolean required() default false;

  int index() default 0;
}
