/*
 * MCS Media Computer Software
 * Copyright (c) 2006 by MCS
 * --------------------------------------
 * Created on 11.04.2006 by w.klaas
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.mcs.utils;

import junit.framework.TestCase;

public class tstWorkingThread extends TestCase {

    class MyRunnable implements Runnable {
        boolean stop = false;

        public void run() {
            while (!stop) {
                try {
                    Thread.sleep(10);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }

        }
    }

    /*
     * Test method for 'de.mcs.utils.WorkingThread.run()'
     */
    public void testRun() throws InterruptedException {
        WorkingThread thread = new WorkingThread();
        assertTrue(thread.isFree());
        thread.start();
        Thread.sleep(100);
        assertTrue(thread.isFree());
        assertFalse(thread.isAlive());
        thread.setBusy();
        assertFalse(thread.isFree());
        thread.setFree();
        assertTrue(thread.isFree());

        thread = new WorkingThread();
        MyRunnable runnable = new MyRunnable();
        thread.setRunnable(runnable);
        assertTrue(thread.isFree());
        thread.start();
        Thread.sleep(100);
        assertFalse(thread.isFree());
        runnable.stop = true;
        Thread.sleep(100);
        assertTrue(thread.isFree());
    }
}
